import es
import gamethread
import playerlib
import shelve
import random
import popuplib
import vecmath 
import time
import string
import psyco
from xpints import *

info = es.AddonInfo()
info.name = '10 Pints Zombie Mod - Environment'
info.version = '2.1.07'
info.basename = '10pintsEnvironment'
info.url = 'www.thefactoidvoid.com'
info.author = 'Largo Usagi'



psyco.full()
'''
It Will allways be assumed that CT's are Zombies and T's are Humans
'''

################################################################################
#						 													  #
#						      Environment Globals                             #
#																			  #
################################################################################
player = xpints.player()

################################################################################
#						 													  #
#							        CSS Events                                #
#																			  #
################################################################################
def load():
	global env
	env = environment()
	gamethread.delayed(1,es.server.queuecmd,'exec xpints.cfg')
	if not es.exists('saycommand', '1x01337XS2'):
		es.regsaycmd('1x01337XS2', '')
	
def unload():
	gamethread.cancelDelayed('loop')
	
def round_start(ev):
	env.checkMode(ev)
	env.roundSetup(ev)
	env.setBotCount(ev)
	
def player_death(ev):
	env.death(ev)
	
def es_map_start(ev):
	random.seed()
	random.jumpahead(random.randint(0,9999))
	env.getMapName(ev)
	env.newMap()
	gamethread.cancelDelayed('loop')
	gamethread.delayed(1,es.server.queuecmd,'exec xpints.cfg')

def round_end(ev):
	env.newRound(ev)
	
def player_spawn(ev):
	env.spawn(ev)
	env.setBotCount(ev)
	
################################################################################
#						 													  #
#					 	      Global Commands                                 #
#																			  #
################################################################################

def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid
	
################################################################################
#						 													  #
#					 	      Zone Manager Class                              #
#																			  #
################################################################################
class zoneManager:
	def __init__(self):
		self.bombSites = []
		self.buyZones = []
		self.hostageRescue = []
		
	def addZones(self):
		tempLen = 0
		entities = []
		self.bombSites = []
		for index in es.createentitylist('func_bomb_target'):
			entities.append(index)
		if entities:
			while tempLen < len(entities):
				mins = vecmath.vector(es.getindexprop(entities[tempLen], 'CBaseEntity.m_Collision.m_vecMins'))
				maxs = vecmath.vector(es.getindexprop(entities[tempLen], 'CBaseEntity.m_Collision.m_vecMaxs'))
				self.bombSites.append((((maxs)), ((mins))))
				tempLen += 1
				es.dbgmsg(0,'Added Bomb Zone')
		tempLen = 0
		entities = []
		self.hostageRescue = []
		for index in es.createentitylist('func_hostage_rescue'):
			entities.append(index)
		if entities:
			while tempLen < len(entities):
				mins = vecmath.vector(es.getindexprop(entities[tempLen], 'CBaseEntity.m_Collision.m_vecMins'))
				maxs = vecmath.vector(es.getindexprop(entities[tempLen], 'CBaseEntity.m_Collision.m_vecMaxs'))
				self.hostageRescue.append((((maxs)), ((mins))))
				tempLen += 1
				es.dbgmsg(0,'Added Rescue Zone')
		tempLen = 0
		entities = []
		self.buyZone = []
		for index in es.createentitylist('func_buyzone'):
			entities.append(index)
		if entities:
			while tempLen < len(entities):
				mins = vecmath.vector(es.getindexprop(entities[tempLen], 'CBaseEntity.m_Collision.m_vecMins'))
				maxs = vecmath.vector(es.getindexprop(entities[tempLen], 'CBaseEntity.m_Collision.m_vecMaxs'))
				self.buyZone.append((((maxs)), ((mins))))
				tempLen += 1
				es.dbgmsg(0,'Added Buy Zone')
	
	def inBombZone(self, userid):
		if self.bombSites:
			loc = es.getplayerlocation(userid)
			for x in self.bombSites:
				x = self.bombSites.index(x)
				if vecmath.isbetweenRect(loc, self.bombSites[x][0], self.bombSites[x][1]):
					return 1
		return 0
	def inBuyZone(self, userid):
		if self.buyZone:
			loc = es.getplayerlocation(userid)
			for x in self.bombSites:
				x = self.bombSites.index(x)
				if vecmath.isbetweenRect(loc, self.buyZone[x][0], self.buyZone[x][1]):
					return 1
		return 0
		
	def inRescueZone(self, userid):
		if self.buyZone:
			loc = es.getplayerlocation(userid)
			for x in self.bombSites:
				x = self.bombSites.index(x)
				if vecmath.isbetweenRect(loc, self.buyZone[x][0], self.buyZone[x][1]):
					return 1
		return 0
	def inZone(self, userid):
		if self.hostageRescue:
			loc = es.getplayerlocation(userid)
			for x in self.hostageRescue:
				x = self.hostageRescue.index(x)
				if vecmath.isbetweenRect(loc, self.hostageRescue[x][0], self.hostageRescue[x][1]):
					return 1
		elif self.buyZone:
			loc = es.getplayerlocation(userid)
			for x in self.buyZone:
				x = self.buyZone.index(x)
				if vecmath.isbetweenRect(loc, self.buyZone[x][0], self.buyZone[x][1]):
					return 1
		elif self.bombSites:
			loc = es.getplayerlocation(userid)
			for x in self.bombSites:
				x = self.bombSites.index(x)
				if vecmath.isbetweenRect(loc, self.bombSites[x][0], self.bombSites[x][1]):
					return 1
		else:
			return 0
	
################################################################################
#						 													  #
#					 	    Environment Class                                 #
#																			  #
################################################################################



class environment:
	def __init__(self):
		self.mode = 0
		self.environmentVars = {
			'rounds':1, 
			'fails':5,
			'mapName':'0',
			'special':0,
			'special1':0,
			'special2':0}
		self.killsLeft = 0
		self.timeLeft = 0
		self.zone = zoneManager()
		self.zHpPerRound = int(es.ServerVar('xp_zombie_bonus_health'))
		self.players = {}
	def getRoundNum(self):
		return self.environmentVars['rounds']
				
	def setBotCount(self,ev):
		if es.getplayerteam(ev['userid']) == 2:
			list = playerlib.getPlayerList('#t')
			playerCount = 0
			for player in list:
				playerCount += 1
				
			if playerCount == 6:
				bots = 1 + ( 4 * playerCount )
			elif playerCount == 1:
				bots = 5 + ( 5 * playerCount )
			else:
				bots = 2 + ( 5 * playerCount ) + playerCount
			es.server.queuecmd('bot_quota %s' %bots)
		
	def spawn(self,ev):
		team = ev['es_userteam']
		userid = ev['userid']
		if team == '3':
			hp = 75 + (self.zHpPerRound * self.environmentVars['rounds'] )
			player.addHealth(ev['userid'], hp)
		if not self.players.has_key(userid):
			self.players[userid]={'kills':0,'deaths':0}
			
	def death(self,ev):
		es.setplayerprop(ev['userid'], 'CCSPlayer.m_iAccount', 0)
		self.players[ev['userid']]['deaths'] += 1
		self.players[ev['attacker']]['kills'] += 1
		if self.mode == 'xh_':
			if ev['es_userteam'] == '3':
				self.killsLeft -= 1
				if self.killsLeft <= 0:
					for x in playerlib.getPlayerList('#ct'):
						player.damage(x.userid, player.getHealth(x.userid) + 50, ev['attacker'])
				if self.killsLeft % 10 == 0:
					es.msg("#multi", "#greenThe Humans Have " + str(self.killsLeft) + " zombies to kill")
				if self.killsLeft <= 9:
					es.msg("#multi", "#greenThe Humans Have " + str(self.killsLeft) + " zombies to kill")
			
	def roundSetup(self,ev):
		if self.mode == 'xp_':
			if self.environmentVars['fails'] >= 0:
				time = self.environmentVars['rounds']
				if time > 9:
					time = 9
				if self.environmentVars['rounds'] == 10:
					self.environmentVars['fails'] = 0
					es.msg("#multi", "#greenFINAL ROUND, Can you turn it up to 11?")
				if self.environmentVars['rounds'] == 11:
					es.msg("#multi", "#greenRound 11...")
					#doshti for round 11
					
				es.msg("#multi", "#greenYou are now on round " + str(self.environmentVars['rounds']) + " and have to survive " + str(time) + " minutes")
			else:
				self.mapVote()
		elif self.mode == 'xh_':
			if self.environmentVars['fails'] >= 0:
				list = playerlib.getPlayerList('#t')
				playerCount = 0
				for player in list:
					playerCount += 1
				self.killsLeft = self.environmentVars['rounds'] * int(es.ServerVar('xh_kills_per_round')) * playerCount
				if self.environmentVars['rounds'] == 10:
					self.environmentVars['fails'] = 0
					es.msg("#multi", "#greenFINAL ROUND, Can you turn it up to 11?")
				if self.environmentVars['rounds'] == 11:
					es.msg("#multi", "#greenRound 11...")
					#doshti for round 11
				es.msg("#multi", "#greenYou are now on round " + str(self.environmentVars['rounds']) + " and have to kill " + str(self.killsLeft) + " Zombies")
			else:
				self.mapVote()
		elif self.mode == 'xe_':
			self.zone.addZones()
			self.xe_loop()
			if self.environmentVars['fails'] >= 0:
				time = 9
				self.timeLeft = self.environmentVars['rounds'] * int(es.ServerVar('xe_time_per_round'))
				if self.environmentVars['rounds'] == 10:
					self.environmentVars['fails'] = 0
					es.msg("#multi", "#greenFINAL ROUND, Can you turn it up to 11?")
				if self.environmentVars['rounds'] == 11:
					es.msg("#multi", "#greenRound 11...")
					#doshti for round 11
				es.msg("#multi", "#greenYou are now on round " + str(self.environmentVars['rounds']) + " and have to camp " + str(self.timeLeft) + " seconds")
			else:
				self.mapVote()
			
	def newRound(self,ev):
		if self.mode == 'xp_':
			es.lightstyle(0,'g')
			if ev['winner'] == '2':
				es.centermsg('Humans Win')
				self.environmentVars['rounds'] += 1
				time = self.environmentVars['rounds']
				es.server.queuecmd('mp_roundtime %s' %time)
				if self.environmentVars['rounds'] == 11:
					doshitforlinkingtoround11epicmode = 0
			if ev['winner'] == '3':
				list = playerlib.getPlayerList('#t')
				playerCount = 0
				es.centermsg( 'Zombies Win')
				for player in list:
					playerCount += 1
				if playerCount > 0:
					self.environmentVars['fails'] -= 1
					if self.environmentVars['fails'] == -1:
						self.gameOver()
				es.msg("#multi", "#greenHumans Failed to Pass round " + str(self.environmentVars['rounds']) + " and have " + str(self.environmentVars['fails']) + " Retrys remaining" )
		elif self.mode == 'xh_':
			es.server.queuecmd('mp_roundtime 9')
			if ev['winner'] == '2':
				es.centermsg('Humans Win')
				self.environmentVars['rounds'] += 1
				if self.environmentVars['rounds'] == 11:
					doshitforlinkingtoround11epicmode = 0
			if ev['winner'] == '3':
				list = playerlib.getPlayerList('#t')
				playerCount = 0
				es.centermsg( 'Zombies Win')
				for player in list:
					playerCount += 1
				if playerCount > 0:
					self.environmentVars['fails'] -= 1
					if self.environmentVars['fails'] == -1:
						self.gameOver()
				es.msg("#multi", "#greenHumans Failed to Pass round " + str(self.environmentVars['rounds']) + " and have " + str(self.environmentVars['fails']) + " Retrys remaining" )
			self.topKills()	
		elif self.mode == 'xe_':
			gamethread.cancelDelayed('loop')
			es.server.queuecmd('mp_roundtime 9')
			if ev['winner'] == '2':
				es.centermsg('Humans Win')
				self.environmentVars['rounds'] += 1
				self.timeLeft = self.environmentVars['rounds'] * int(es.ServerVar('xe_time_per_round'))
				if self.environmentVars['rounds'] == 11:
					doshitforlinkingtoround11epicmode = 0
			if ev['winner'] == '3':
				list = playerlib.getPlayerList('#t')
				playerCount = 0
				es.centermsg( 'Zombies Win')
				for player in list:
					playerCount += 1
				if playerCount > 0:
					self.environmentVars['fails'] -= 1
					if self.environmentVars['fails'] == -1:
						self.gameOver()
				es.msg("#multi", "#greenHumans Failed to Pass round " + str(self.environmentVars['rounds']) + " and have " + str(self.environmentVars['fails']) + " Retrys remaining" )
		self.players = {}
	
	def topKills(self):
		try:
			count = 0
			listp = []
			listk = []
			for userid in self.players:
				listp.append(userid)
				listk.append(self.players[userid]['kills'])
			clist = zip(listk, listp)
			clist.sort()
			clist = reversed(clist)
			es.msg("#multi", "#lightgreenTop Killers")
			for k,u in clist:
				if count <= 2:
					es.msg("#multi", "#lightgreen" + str(playerlib.getPlayer(u).name) + ' with ' + str(k) + ' Kills')
					count += 1
		except:
			pass

	def xe_loop(self):
		check = 1
		count = 0
		for x in playerlib.getPlayerList('#t,#alive'):
			count += 1
			if self.zone.inBombZone(x.userid) == 0:
				check = 0
		if check == 1 and count != 0:
			gamethread.cancelDelayed('loop')
			self.xe_countDown()
		else:
			if count != 0:
				es.msg("#multi", "#greenAll Humans Need to get to a hold out location" )
				gamethread.delayedname(10, 'loop', self.xe_loop)
		
	def xe_countDown(self):
		check = 1
		count = 0
		for x in playerlib.getPlayerList('#t,#alive'):
			count += 1
			if self.zone.inBombZone(x.userid) == 0:
				check = 0
		if check == 1 and count != 0:
			self.timeLeft -= 1
			if self.timeLeft <= 0:
				for x in playerlib.getPlayerList('#ct'):
					player.damage(x.userid, player.getHealth(x.userid) + 50, 0)
			else:
				es.msg("#multi", "#green" + str(self.timeLeft) + ' Seconds Left' )
				gamethread.delayedname(1, 'loop', self.xe_countDown)
		else:
			gamethread.cancelDelayed('loop')
			self.xe_loop()

	
	def gameOver(self):
		es.msg("#multi", "#green----GAME OVER----" )
		es.msg("#multi", "#green----GAME OVER----" )
		es.msg("#multi", "#green----GAME OVER----" )
		es.msg("#multi", "#green----GAME OVER----" )
		es.msg("#multi", "#green----GAME OVER----" )
		es.server.queuecmd('mp_roundtime 9')
		es.server.queuecmd('mp_freezetime 60')
		for userid in es.getUseridList():
			player.setSpeed(userid, .0000000000000000001)
		
	def mapVote(self):
		es.server.queuecmd('mp_roundtime 9')
		es.server.queuecmd('mp_freezetime 60')
		maps = ('xp_italy','xp_dust','xp_dust2')
		es.msg("#multi", "#greenStarting Map Vote" )
		gamethread.delayed(10,es.server.queuecmd,('changelevel ' + random.choice(maps))) #temp fix for map problem
		list = playerlib.getPlayerList('#all')
		for players in list:
			player.setSpeed(players.userid, .0000000000000000001)
		
	def newMap(self):
		self.environmentVars['rounds'] = 1
		self.environmentVars['fails'] = 5
		self.environmentVars['special1'] = 0
		self.environmentVars['special2'] = 0
		self.environmentVars['special'] = 0
		es.server.queuecmd('sv_skyname sky_borealis01')
		es.server.queuecmd('bot_join_after_player 1')
		es.server.queuecmd('mp_autoteambalance 0')
		es.server.queuecmd('mp_limitteams 0')
		es.server.queuecmd('bot_difficulty 3')
		es.server.queuecmd('bot_quota_mode fill')
		es.server.queuecmd('mp_humanteam t')
		es.server.queuecmd('mp_roundtime 1')
		es.server.queuecmd('bot_kick all')
		self.zone.addZones()
	
	def getMapName(self,ev):
			self.environmentVars['mapName'] = ev['mapName']
			
	def checkMode(self,ev):
			userid = es.getuserid()
			es.server.queuecmd('es_xfire %d func_buyzone Disable' % userid)
			if 'xp_' in self.environmentVars['mapName']:
				self.xp_mode()
				self.mode = 'xp_'
			elif 'xh_' in self.environmentVars['mapName'] or 'fy_' in self.environmentVars['mapName']:
				self.mode = 'xh_'
			elif 'xe_' in self.environmentVars['mapName'] or 'de_' in self.environmentVars['mapName']:
				self.mode = 'xe_'
			else:
				self.enableCompatabilityMode()
				self.mode = 'xp_'
	def enableCompatabilityMode(self):
		es.lightstyle(0,'b')
		userid = es.getuserid()
		es.dbgmsg(0,'Enabling Compatability Mode')
		if len(es.createentitylist('func_bomb_target')):
			es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
			es.server.queuecmd('es_xfire %d weapon_c4 Kill' %userid)
            
		elif len(es.createentitylist('func_hostage_rescue')):
			es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
			es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)
		if len(es.createentitylist('func_bomb_target')):
			es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
			es.server.queuecmd('es_xfire %d weapon_c4 Kill' % userid)
		elif len(es.createentitylist('func_hostage_rescue')):
			es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
			es.server.queuecmd('es_xfire %d hostage_entity Kill' % userid)
		es.msg("#green", "This Server is now running the current map in compatability mode")
	def xp_mode(self):
		userid = es.getuserid()
		if len(es.createentitylist('func_hostage_rescue')):
			es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
			es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)
		es.msg("#green", "This Server is now running the current map in Zombie Survival mode")
	def xh_mode(self):
		userid = es.getuserid()
		userid = es.getuserid()
		es.dbgmsg(0,'Enabling Compatability Mode')
		if len(es.createentitylist('func_bomb_target')):
			es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
			es.server.queuecmd('es_xfire %d weapon_c4 Kill' %userid)
		elif len(es.createentitylist('func_hostage_rescue')):
			es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
			es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)
		if len(es.createentitylist('func_bomb_target')):
			es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
			es.server.queuecmd('es_xfire %d weapon_c4 Kill' % userid)
		elif len(es.createentitylist('func_hostage_rescue')):
			es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
			es.server.queuecmd('es_xfire %d hostage_entity Kill' % userid)
		es.msg("#green", "This Server is now running the current map in Zombie Hunt mode")
	def xe_mode(self):
		userid = es.getuserid()
		if len(es.createentitylist('func_bomb_target')):
			es.server.queuecmd('es_xfire %d weapon_c4 Kill' % userid)
		elif len(es.createentitylist('func_hostage_rescue')):
			es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
			es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)
		es.msg("#green", "This Server is now running the current map in Zombie Escape mode")



#es_unload xpints;es_load xpints; changelevel cs_office			
##################################################################################################
#EOF
##################################################################################################